#include "lcd.h"
#include "spi.h"
#include "dma.h"




#if( LCD_SPI_SOFTWARE == LCD_SPI_DRIVER )

void LCD_SPI_Start(void)
{
    LCD_MOSI_OUT = 0;
    //delay_us(1);

    LCD_SCLK_OUT = 0;
    //delay_us(1);

    LCD_CS_OUT = 0;
    //delay_us(1);
}


void LCD_SPI_Stop(void)
{
    LCD_CS_OUT = 1;
    //delay_us(1);

    LCD_MOSI_OUT = 1;
    //delay_us(1);

    LCD_SCLK_OUT = 1;
    //delay_us(1);
}


u8 LCD_SPI_ReadWrite_Byte(u8 dat)
{
    u8 i;
    u8 ret = 0;
    
    LCD_MISO_IN = 1;  //51ƬҪ
    //delay_us(1);  

    for( i=0; i<8; i++ )
    {
        ret <<= 1;
        if( LCD_MISO_IN ) ret++;
        
        LCD_MOSI_OUT = (dat&0x80) >> 7;
        dat <<= 1;

        //delay_us(1); 
        LCD_SCLK_OUT = 1; 
        //delay_us(1);
        LCD_SCLK_OUT = 0;
        //delay_us(1);
    }                      

    return ret;
}

#else

void LCD_SPI_Start(void)
{
    LCD_CS_OUT = 0;
    //delay_us(1);
}


void LCD_SPI_Stop(void)
{
    LCD_CS_OUT = 1;
    //delay_us(1);
}


u8 LCD_SPI_ReadWrite_Byte(u8 dat)
{
    return SPI_ReadWrite_Byte(dat);
}

#endif


void LCD_Writ_Bus(u8 dat) 
{
	LCD_SPI_Start();	
	LCD_SPI_ReadWrite_Byte(dat);
	LCD_SPI_Stop();	
}

/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_DATA8(u8 dat)
{
	LCD_Writ_Bus(dat);
}


/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_DATA(u16 dat)
{
	LCD_Writ_Bus((u8)(dat>>8));
	LCD_Writ_Bus((u8)dat);
}


/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_REG(u8 dat)
{
	LCD_DC_OUT = 0;//д
	LCD_Writ_Bus(dat);
	LCD_DC_OUT = 1;//д
}


/******************************************************************************
      ˵ʼͽַ
      ݣx1,x2 еʼͽַ
                y1,y2 еʼͽַ
      ֵ  
******************************************************************************/
void LCD_Address_Set(u16 x1,u16 y1,u16 x2,u16 y2)
{
	if(USE_HORIZONTAL==0)
	{
		LCD_WR_REG(0x2a);//еַ
		LCD_WR_DATA(x1+2);
		LCD_WR_DATA(x2+2);
		LCD_WR_REG(0x2b);//еַ
		LCD_WR_DATA(y1+1);
		LCD_WR_DATA(y2+1);
		LCD_WR_REG(0x2c);//д
	}
	else if(USE_HORIZONTAL==1)
	{
		LCD_WR_REG(0x2a);//еַ
		LCD_WR_DATA(x1+2);
		LCD_WR_DATA(x2+2);
		LCD_WR_REG(0x2b);//еַ
		LCD_WR_DATA(y1+1);
		LCD_WR_DATA(y2+1);
		LCD_WR_REG(0x2c);//д
	}
	else if(USE_HORIZONTAL==2)
	{
		LCD_WR_REG(0x2a);//еַ
		LCD_WR_DATA(x1+1);
		LCD_WR_DATA(x2+1);
		LCD_WR_REG(0x2b);//еַ
		LCD_WR_DATA(y1+2);
		LCD_WR_DATA(y2+2);
		LCD_WR_REG(0x2c);//д
	}
	else
	{
		LCD_WR_REG(0x2a);//еַ
		LCD_WR_DATA(x1+1);
		LCD_WR_DATA(x2+1);
		LCD_WR_REG(0x2b);//еַ
		LCD_WR_DATA(y1+2);
		LCD_WR_DATA(y2+2);
		LCD_WR_REG(0x2c);//д
	}
}


//ʼSPI IO
void LCD_IO_Init(void)
{
    #if( LCD_SPI_SOFTWARE == LCD_SPI_DRIVER )
    {
        LCD_CS_OUT = 1;
        LCD_SCLK_OUT = 1;
        LCD_MOSI_OUT = 1;
    }
    #else
    {
        LCD_CS_OUT = 1;
        SPI_Init();

        #if( LCD_SPI_HARDWARE_DMA == LCD_SPI_DRIVER )
        SPI_DMA_Init();
        #endif
    }
    #endif


    LCD_DC_OUT = 1;  //д
    LCD_RST_OUT = 1;
    LCD_BLK_OUT = 1;
    
}


/******************************************************************************
      ˵LCDʼ
      ݣ
      ֵ  
******************************************************************************/
void LCD_Init(void)
{
	u8 i, j;

	LCD_IO_Init();

	LCD_RST_OUT = 0;
	delay_ms(1); //ԭ100ms
	LCD_RST_OUT = 1; 
	delay_ms(1); //ԭ100ms
	LCD_BLK_OUT = 1;
	delay_ms(1); //ԭ100ms
	//************* Start Initial Sequence **********//
	LCD_WR_REG(0x11); //Sleep out 
	delay_ms(1); //ԭ120ms 
	//------------------------------------ST7735S Frame Rate-----------------------------------------// 
	LCD_WR_REG(0xB1); 
	LCD_WR_DATA8(0x05); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_REG(0xB2); 
	LCD_WR_DATA8(0x05);
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_REG(0xB3); 
	LCD_WR_DATA8(0x05); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x05); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	//------------------------------------End ST7735S Frame Rate---------------------------------// 
	LCD_WR_REG(0xB4); //Dot inversion 
	LCD_WR_DATA8(0x03); 
	//------------------------------------ST7735S Power Sequence---------------------------------// 
	LCD_WR_REG(0xC0); 
	LCD_WR_DATA8(0x28); 
	LCD_WR_DATA8(0x08); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_REG(0xC1); 
	LCD_WR_DATA8(0XC0); 
	LCD_WR_REG(0xC2); 
	LCD_WR_DATA8(0x0D); 
	LCD_WR_DATA8(0x00); 
	LCD_WR_REG(0xC3); 
	LCD_WR_DATA8(0x8D); 
	LCD_WR_DATA8(0x2A); 
	LCD_WR_REG(0xC4); 
	LCD_WR_DATA8(0x8D); 
	LCD_WR_DATA8(0xEE); 
	//---------------------------------End ST7735S Power Sequence-------------------------------------// 
	LCD_WR_REG(0xC5); //VCOM 
	LCD_WR_DATA8(0x1A); 
	LCD_WR_REG(0x36); //MX, MY, RGB mode 
	if(USE_HORIZONTAL==0)LCD_WR_DATA8(0x00);
	else if(USE_HORIZONTAL==1)LCD_WR_DATA8(0xC0);
	else if(USE_HORIZONTAL==2)LCD_WR_DATA8(0x70);
	else LCD_WR_DATA8(0xA0); 
	//------------------------------------ST7735S Gamma Sequence---------------------------------// 
	LCD_WR_REG(0xE0); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_DATA8(0x22); 
	LCD_WR_DATA8(0x07); 
	LCD_WR_DATA8(0x0A); 
	LCD_WR_DATA8(0x2E); 
	LCD_WR_DATA8(0x30); 
	LCD_WR_DATA8(0x25); 
	LCD_WR_DATA8(0x2A); 
	LCD_WR_DATA8(0x28); 
	LCD_WR_DATA8(0x26); 
	LCD_WR_DATA8(0x2E); 
	LCD_WR_DATA8(0x3A); 
	LCD_WR_DATA8(0x00); 
	LCD_WR_DATA8(0x01); 
	LCD_WR_DATA8(0x03); 
	LCD_WR_DATA8(0x13); 
	LCD_WR_REG(0xE1); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_DATA8(0x16); 
	LCD_WR_DATA8(0x06); 
	LCD_WR_DATA8(0x0D); 
	LCD_WR_DATA8(0x2D); 
	LCD_WR_DATA8(0x26); 
	LCD_WR_DATA8(0x23); 
	LCD_WR_DATA8(0x27); 
	LCD_WR_DATA8(0x27); 
	LCD_WR_DATA8(0x25); 
	LCD_WR_DATA8(0x2D); 
	LCD_WR_DATA8(0x3B); 
	LCD_WR_DATA8(0x00); 
	LCD_WR_DATA8(0x01); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_DATA8(0x13); 
	//------------------------------------End ST7735S Gamma Sequence-----------------------------// 
	LCD_WR_REG(0x3A); //65k mode 
	LCD_WR_DATA8(0x05);

	LCD_Address_Set(0,0,LCD_W-1,LCD_H-1);//ʾΧ
	for(i=0;i<LCD_H;i++)  //
	{													   	 	
		for(j=0;j<LCD_W;j++)
		{
			LCD_WR_DATA(0xFFFF);
		}
	}

	LCD_WR_REG(0x29); //Display on 
}


/******************************************************************************
      ˵ָɫ
      ݣxsta,ysta   ʼ
                xend,yend   ֹ
								color       Ҫɫ
      ֵ  
******************************************************************************/
void LCD_Fill(u16 ysta, u16 xsta, u16 yend, u16 xend, u16 color)
{          
	u16 i,j; 
	LCD_Address_Set(xsta,ysta,xend-1,yend-1);//ʾΧ
	for(i=ysta;i<yend;i++)
	{													   	 	
		for(j=xsta;j<xend;j++)
		{
			LCD_WR_DATA(color);
		}
	} 					  	    
}


void LCD_DMA_Fill(u16 ysta, u16 xsta, u16 yend, u16 xend, u8 *color)
{
    SPI_DMA_TX_Config(color, 2 * (xend - xsta) * (yend - ysta));  //STC32ֻ8λݴ䣬ֽҪ * 2

	LCD_Address_Set(xsta, ysta, xend-1, yend-1);//ʾΧ  õӲSPI
    LCD_SPI_Start();  //CS = 0;
    SPI_DMA_Run();  //ֻDMA
    LCD_SPI_Stop();  //CS = 1;

    SPI_DMA_Disable();

}


#define  DIS_BUF_LEN  (2 * 8 * 160)  //STC32ֻ8λݴ䣬ֽҪ * 2
static u8 xdata Dis_Buff[DIS_BUF_LEN];

void Display_Test(u16 count)
{
    u16 i, j;

    switch( count % 5  )
    {
        case 0: count = 0XBC40; break;
        case 1: count = 0X01CF; break;
        case 2: count = 0X841F; break;
        case 3: count = 0XA651; break;
        case 4: count = 0xF800; break;
    }

    
    for( i=0; i<DIS_BUF_LEN / 2; i++ ) 
    {
        Dis_Buff[i * 2 + 0] = count >> 8;
        Dis_Buff[i * 2 + 1] = count;
    }

    /*
    LCD_DMA_Fill(0, 0, 8, 160, Dis_Buff);  //STC32ֻ8λݴ䣬ֽҪ * 2
    LCD_DMA_Fill(8, 0, 16, 160, Dis_Buff);
    LCD_DMA_Fill(16, 0, 24, 160, Dis_Buff);*/

    for( j=0; j<128/8; j++ )
    {
        #if( LCD_SPI_HARDWARE_DMA == LCD_SPI_DRIVER )
        LCD_DMA_Fill(j * 8, 0, j * 8 + 8, 160, Dis_Buff);  //STC32ֻ8λݴ䣬ֽҪ * 2
        #else
        LCD_Fill(j * 8, 0, j * 8 + 8, 160, count);
        #endif
    }
    
}