#include "spi.h"


#define  MAIN_Fosc  24000000UL


/*************  س    **************/

#define HSCK_MCLK       0
#define HSCK_PLL        1
#define HSCK_SEL        HSCK_PLL

#define PLL_96M         0
#define PLL_144M        1
#define PLL_SEL         PLL_96M

#define CKMS            0x80
#define HSIOCK          0x40
#define MCK2SEL_MSK     0x0c
#define MCK2SEL_SEL1    0x00
#define MCK2SEL_PLL     0x04
#define MCK2SEL_PLLD2   0x08
#define MCK2SEL_IRC48   0x0c
#define MCKSEL_MSK      0x03
#define MCKSEL_HIRC     0x00
#define MCKSEL_XOSC     0x01
#define MCKSEL_X32K     0x02
#define MCKSEL_IRC32K   0x03

#define ENCKM           0x80
#define PCKI_MSK        0x60
#define PCKI_D1         0x00
#define PCKI_D2         0x20
#define PCKI_D4         0x40
#define PCKI_D8         0x60





void SPI_init(void)
{
    //P_SW2 |= 0x80;

    //ѡPLLʱ
#if (PLL_SEL == PLL_96M)
    CLKSEL &= ~CKMS;            //ѡPLL96MΪPLLʱ
#elif (PLL_SEL == PLL_144M)
    CLKSEL |= CKMS;             //ѡPLL144MΪPLLʱ
#else
    CLKSEL &= ~CKMS;            //ĬѡPLL96MΪPLLʱ
#endif

    //ѡPLLʱӷƵ,֤ʱΪ12M
    USBCLK &= ~PCKI_MSK;
#if (MAIN_Fosc == 12000000UL)
    USBCLK |= PCKI_D1;          //PLLʱ1Ƶ
#elif (MAIN_Fosc == 24000000UL)
    USBCLK |= PCKI_D2;          //PLLʱ2Ƶ
#elif (MAIN_Fosc == 48000000UL)
    USBCLK |= PCKI_D4;          //PLLʱ4Ƶ
#elif (MAIN_Fosc == 96000000UL)
    USBCLK |= PCKI_D8;          //PLLʱ8Ƶ
#else
    USBCLK |= PCKI_D1;          //ĬPLLʱ1Ƶ
#endif

    //PLL
    USBCLK |= ENCKM;            //ʹPLLƵ
    delay_ms(1);                //ȴPLLƵ

    //ѡHSPWM/HSSPIʱ
#if (HSCK_SEL == HSCK_MCLK)
    CLKSEL &= ~HSIOCK;          //HSPWM/HSSPIѡʱΪʱԴ
#elif (HSCK_SEL == HSCK_PLL)
    CLKSEL |= HSIOCK;           //HSPWM/HSSPIѡPLLʱΪʱԴ
#else
    CLKSEL &= ~HSIOCK;          //ĬHSPWM/HSSPIѡʱΪʱԴ
#endif

    //ʱõ96M

    HSCLKDIV = 4;               //HSPWM/HSSPIʱԴ4Ƶ

    P_SW1 = (P_SW1 & ~(3<<2)) | (1<<2);     //IOл. 0: P1.2/P5.4 P1.3 P1.4 P1.5, 1: P2.2 P2.3 P2.4 P2.5, 2: P5.4 P4.0 P4.1 P4.3, 3: P3.5 P3.4 P3.3 P3.2
    SSIG = 1; // SS Źܣʹ MSTR ȷǴӻ
    SPEN = 1; //ʹ SPI 
    DORD = 0; //ȷ/ݵĸλ MSB
    MSTR = 1; //ģʽ
    CPOL = 0; //SCLK ʱΪ͵ƽSCLK ǰʱΪأʱΪ½
    CPHA = 0; // SS ܽΪ͵ƽһλݲ SCLK ĺʱظı
    SPCTL = (SPCTL & ~3) | 3;   //SPI ʱƵѡ, 0: 4T, 1: 8T,  2: 16T,  3: 2T

    SPIF = 1;   //SPIF־
    WCOL = 1;   //WCOL־

    HSSPI_CFG2 |= 0x20;         //ʹSPIģʽ

    //P_SW2 &= ~0x80; 
}


u8 SPI_ReadWrite_Byte(u8 dat)
{
    SPIF = 1;   //SPIF־
    WCOL = 1;   //WCOL־
    SPDAT = dat;
    while( 0 == SPIF );
    return (SPDAT);
}




